# $Revision: 1.55 $, $Date: 2011/12/12 13:53:54 $
# TODO:
#	- other operation modes: rails/webrick, mongrel?\
#
# for reposman
%include	/usr/lib/rpm/macros.perl
Summary:	Flexible project management web application
Name:		redmine
Version:	1.3.0
Release:	1
License:	GPL v2
Group:		Applications/WWW
Source0:	http://rubyforge.org/frs/download.php/75597/%{name}-%{version}.tar.gz
# Source0-md5:	4aa3534ae6a06bc3732b1c8b6eee7c60
Source2:	%{name}.conf
# Shove UTF-8 down rails throat, needed for rails < 3
Source3:	%{name}-fix_params.rb
Source4:	%{name}-fix_renderable.rb
Source5:	%{name}-fix_utf.rb
Patch0:		%{name}-pld.patch
Patch1:		%{name}-ldap.patch
Patch2:		%{name}-utf-regex.patch
Patch3:		%{name}-nogems.patch
Patch4:		%{name}-maildomain.patch
Patch5:		%{name}-gantt.patch
Patch6:		%{name}-git-parse.patch
Patch7:		%{name}-tmail.patch
Patch8:		%{name}-utf8.patch
URL:		http://www.redmine.org/
BuildRequires:	dos2unix
BuildRequires:	perl-base
BuildRequires:	rpm-perlprov
BuildRequires:	rpmbuild(macros) >= 1.202
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/sbin/useradd
Requires:	apache(mod_rails)
Requires:	ruby-RMagick
Requires:	ruby-SyslogLogger
Requires:	ruby-coderay >= 1.0.0
Requires:	ruby-i18n >= 0.4.2
Requires:	ruby-rails2 = 2.3.14
Requires:	ruby-rake
Requires:	ruby-rubytree >= 0.5.2
Requires:	webapps
Requires:	webserver(alias)
Suggests:	cvs
Suggests:	git-core
Suggests:	mercurial
Suggests:	ruby-net-ldap
Suggests:	ruby-mocha
Suggests:	ruby-mysql-library
Suggests:	ruby-openid >= 2.1.4
Suggests:	subversion >= 1.3
Provides:	user(redmine)
# Does not work AT ALL with rails 3 currently
Conflicts:	ruby-rails >= 3.0
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}

%description
Redmine is a flexible project management web application.

Overview:
- Multiple projects support
- Flexible role based access control.
- Flexible issue tracking system
- Gantt chart and calendar
- News, documents & files management
- Feeds & email notifications.
- Per project wiki
- Per project forums
- Simple time tracking functionality
- Custom fields for issues, projects and users
- SCM integration (SVN, CVS, Git, Mercurial, Bazaar and Darcs)
- Multiple LDAP authentication support
- User self-registration support
- Multilanguage support
- Multiple databases support

Written using Ruby on Rails framework, it is cross-platform and
cross-database.

%package mailhandler
Summary:	Forward emails from email server to redmine
Group:		Applications/WWW

%description mailhandler
Reads an email from standard input and forward it to a Redmine server
through a HTTP request.

%package reposman
Summary:	SCM repository manager for redmine
Group:		Applications/WWW
Requires:	ruby-activeresource

%description reposman
SCM repository manager for redmine.

%package testsuite
Summary:	Test suite for Redmine
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}

%description testsuite
Test suite for Redmine.

%prep
%setup -q

%{__rm} -r vendor/gems
%{__rm} -r vendor/plugins/ruby-net-ldap*
%{__rm} -r vendor/rails

find \( -name '*.rb' -o -name '*.rake' \) -print0 | xargs -0 dos2unix -k -q

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

# ruby 1.9.3 became very strict about escaping
%{__sed} -i  -e 's/\([^\]\+\):\\\([^\]\+\)/\1:\\\\\2/g' \
	     -e 's/^\([^:]\+:\s*\)\([^"]*\)%\([^"]*\)$/\1"\2%\3"/g' \
	     config/locales/*.yml

find -type f -print0 | \
	xargs -0 %{__sed} -i -e 's,/usr/bin/env ruby,%{__ruby},' \
			     -e 's,/usr/local/bin/ruby,%{__ruby},'

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_datadir}/%{name}} \
	$RPM_BUILD_ROOT{%{_bindir},%{perl_vendorlib}/Apache} \
	$RPM_BUILD_ROOT/var/lib/%{name}/{files,log,plugin_assets,tmp}

# Check if everything is installed on update!

cp -a Rakefile app lib public script test vendor $RPM_BUILD_ROOT%{_datadir}/%{name}

install -p public/dispatch.cgi.example $RPM_BUILD_ROOT%{_datadir}/%{name}/public/dispatch.cgi
install -p public/dispatch.fcgi.example $RPM_BUILD_ROOT%{_datadir}/%{name}/public/dispatch.fcgi

install -p extra/mail_handler/rdm-mailhandler.rb $RPM_BUILD_ROOT%{_bindir}

install -p extra/svn/reposman.rb $RPM_BUILD_ROOT%{_bindir}
install -p extra/svn/svnserve.wrapper $RPM_BUILD_ROOT%{_bindir}
install -p extra/svn/Redmine.pm $RPM_BUILD_ROOT%{perl_vendorlib}/Apache

cp -a config $RPM_BUILD_ROOT%{_sysconfdir}
install -p config/additional_environment.rb.example $RPM_BUILD_ROOT%{_sysconfdir}/config/additional_environment.rb
install -p config/configuration.yml.example $RPM_BUILD_ROOT%{_sysconfdir}/config/configuration.yml
install -p config/database.yml.example $RPM_BUILD_ROOT%{_sysconfdir}/config/database.yml
install -p config/settings.yml $RPM_BUILD_ROOT%{_sysconfdir}/config/settings.yml
ln -s %{_sysconfdir}/config $RPM_BUILD_ROOT%{_datadir}/%{name}

install %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/config/initializers/fix_params.rb
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/config/initializers/fix_renderable.rb
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/config/initializers/fix_utf.rb

cp -a db $RPM_BUILD_ROOT/var/lib/%{name}
ln -s /var/lib/%{name}/db $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -s /var/lib/%{name}/files $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -s /var/lib/%{name}/log $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -s /var/lib/%{name}/tmp $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -s /var/lib/%{name}/plugin_assets $RPM_BUILD_ROOT%{_datadir}/%{name}/public

install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf

%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/config/*.example
%{__rm} $RPM_BUILD_ROOT%{_datadir}/%{name}/public/*.example

%{__sed} -i -e 's,^RAILS_ROOT = .*,RAILS_ROOT = "%{_datadir}/%{name}",' $RPM_BUILD_ROOT%{_sysconfdir}/config/boot.rb

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%useradd -u 212 -d %{_datadir}/%{name} -s /bin/false -c "Redmine User" -g nobody redmine

%post
%banner -e %{name} <<-EOF
You may need to update redmine database, to do this run
(assuming 'production' is the name of redmine rails environment):
cd %{_datadir}/%{name}
rake db:migrate RAILS_ENV=production 
EOF

%postun
if [ "$1" = "0" ]; then
	%userremove redmine
fi

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}
%addusertogroup -q redmine http

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%files
%defattr(644,root,root,755)
%doc README.rdoc doc/* public/*.example config/*.example
%doc extra/sample_plugin extra/svn/create_views.sql
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%dir %attr(755,redmine,root) %{_sysconfdir}/config
%attr(644,redmine,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config/*.rb
%attr(640,redmine,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config/*.yml
%dir %attr(755,redmine,root) %{_sysconfdir}/config/environments
%attr(644,redmine,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config/environments/development.rb
%attr(644,redmine,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config/environments/production.rb
%dir %attr(755,redmine,root) %{_sysconfdir}/config/initializers
%attr(644,redmine,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config/initializers/*.rb
%dir %attr(755,redmine,root) %{_sysconfdir}/config/locales
%attr(644,redmine,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config/locales/*.yml
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/public
%{_datadir}/%{name}/Rakefile
%{_datadir}/%{name}/app
%{_datadir}/%{name}/lib
%{_datadir}/%{name}/public/help
%{_datadir}/%{name}/public/images
%{_datadir}/%{name}/public/javascripts
%{_datadir}/%{name}/public/plugin_assets
%{_datadir}/%{name}/public/stylesheets
%{_datadir}/%{name}/public/themes
%{_datadir}/%{name}/public/*.html
%{_datadir}/%{name}/public/favicon.ico
%attr(755,redmine,root) %{_datadir}/%{name}/public/dispatch.*
%dir %{_datadir}/%{name}/script
%dir %{_datadir}/%{name}/script/performance
%dir %{_datadir}/%{name}/script/process
%attr(755,root,root) %{_datadir}/%{name}/script/[a-o]*
%attr(755,root,root) %{_datadir}/%{name}/script/plugin
%attr(755,root,root) %{_datadir}/%{name}/script/[q-z]*
%attr(755,root,root) %{_datadir}/%{name}/script/performance/*
%attr(755,root,root) %{_datadir}/%{name}/script/process/*
%{_datadir}/%{name}/vendor
%exclude %{_datadir}/%{name}/vendor/plugins/*/test
%dir %attr(755,redmine,root) /var/lib/%{name}
%dir %attr(755,redmine,root) /var/lib/%{name}/db
%dir %attr(755,redmine,root) /var/lib/%{name}/db/migrate
%attr(644,redmine,root) /var/lib/%{name}/db/migrate/*
%dir %attr(755,redmine,root) /var/lib/%{name}/files
%dir %attr(755,redmine,root) /var/lib/%{name}/log
%dir %attr(755,redmine,root) /var/lib/%{name}/plugin_assets
%dir %attr(755,redmine,root) /var/lib/%{name}/tmp
%{_datadir}/%{name}/config
%{_datadir}/%{name}/db
%{_datadir}/%{name}/files
%{_datadir}/%{name}/log
%{_datadir}/%{name}/tmp

%files reposman
%defattr(644,root,root,755)
%doc extra/svn/create_views.sql
%attr(755,root,root) %{_bindir}/reposman.rb
%attr(755,root,root) %{_bindir}/svnserve.wrapper
%{perl_vendorlib}/Apache/Redmine.pm

%files mailhandler
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/rdm-mailhandler.rb

%files testsuite
%defattr(644,root,root,755)
%attr(655,redmine,root) %{_sysconfdir}/config/environments/test*.rb
%{_datadir}/%{name}/test
%{_datadir}/%{name}/vendor/plugins/*/test

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: redmine.spec,v $
Revision 1.55  2011/12/12 13:53:54  baggins
- rel 1

Revision 1.54  2011/12/12 13:42:33  baggins
- Ruby 1.9: add "encoding: utf-8" header to fix broken "HTML escapes"

Revision 1.53  2011/12/12 12:23:38  baggins
- 1.3.0
- R rails 2.3.14

Revision 1.52  2011/12/09 22:01:48  baggins
- rel 2
- works on ruby 1.9.3

Revision 1.51  2011/12/09 21:50:46  baggins
- fix regexp

Revision 1.50  2011/12/09 21:44:39  baggins
- work around ruby 1.9.3 anal retentiveness

Revision 1.49  2011/12/09 13:43:59  baggins
- added TODO

Revision 1.48  2011/12/09 11:21:50  baggins
- rel 1

Revision 1.47  2011/12/09 10:17:26  baggins
- updated to 1.2.2

Revision 1.46  2011/07/08 12:28:04  baggins
- added explicit i18n dep instead of gem requirement
- fix tmail requirement

Revision 1.45  2011/07/08 11:26:54  baggins
- updated docs

Revision 1.44  2011/07/08 11:14:47  baggins
- updated patches to 1.2.0
- updated install and R

Revision 1.43  2011/07/08 10:12:20  baggins
- started update to 1.2.0
- bundled rfpdf is ok now
- use __rm macro

Revision 1.42  2011/06/22 11:02:16  baggins
- R old rails

Revision 1.41  2011/04/12 10:33:49  baggins
- rel 2
- one more git adapter hiccup

Revision 1.40  2011/01/23 14:57:46  sparky
- dropped unused BR: ruby-rake

Revision 1.39  2010/12/06 09:42:14  baggins
- rel 1

Revision 1.38  2010/12/04 23:28:47  baggins
- LDAP attrs encoding still needs forced UTF-8

Revision 1.37  2010/12/03 21:31:12  baggins
- more descriptive banner

Revision 1.36  2010/12/03 13:48:11  baggins
- banner about database update

Revision 1.35  2010/12/03 12:53:30  baggins
- add redmine user to http group (redmine has to access configs in webapps dir)

Revision 1.34  2010/12/02 13:20:14  baggins
- 1.0.4, builds but completely untested
- 0.9.6 is on REDMINE_0_9 branch
- updated patches
- removed ldap patch, there is net-ldap for ruby 1.9 now

Revision 1.33  2010/12/02 11:45:28  baggins
- 0.9.6
- make git log parser encoding indepentent (or we'll get
  'invalid byte sequence in UTF-8' and http 500 in case of problems)

Revision 1.32  2010/06/21 12:30:05  baggins
- rel 1

Revision 1.31  2010/06/21 12:23:13  baggins
- up to 0.9.4

Revision 1.30  2010/06/21 11:24:20  baggins
- rel 5
- fixed parsing and verify of wiki titles

Revision 1.29  2010/05/13 20:26:45  glen
- keep comment with line it is affecting

Revision 1.28  2010/05/13 17:26:48  sparky
- BR: perl-base (only for perl macros), rpm-perlprov

Revision 1.27  2010/03/13 17:56:34  baggins
- rel 4
- fix rendering gantt template

Revision 1.26  2010/03/12 23:43:14  baggins
- rel 3
- mercurial overhaul

Revision 1.25  2010/03/12 21:09:27  baggins
- rel 2

Revision 1.24  2010/03/12 21:08:45  baggins
- fixed CSV files
- replaced bundled pdf generator with something that groks utf
	http://github.com/edwinmoss/rfpdf/
	http://www.redmine.org/issues/61
- added missing dir

Revision 1.23  2010/03/11 22:23:20  baggins
- rel 1

Revision 1.22  2010/03/11 19:07:27  baggins
- secure perms on configs that contain passwords

Revision 1.21  2010/03/09 22:03:11  baggins
- really force UTF-8
- fix files
- removed post (only valid on first deployment - admin job)
- removed dependency on gem
- add default mail domain support for ldap accounts
- fix stupid dos2unix conversions

Revision 1.20  2010/03/09 12:06:23  baggins
- typos

Revision 1.19  2010/03/08 23:17:55  baggins
- hack/workaround for UTF-8 brokeness in rails 2.3 on ruby 1.9

Revision 1.18  2010/03/07 22:32:06  baggins
- replace ruby-net-ldap with ruby-ldap (net-ldap is quite dead
  and incompatible with ruby 1.9)

Revision 1.17  2010/03/07 11:04:09  baggins
- TODO
- added post
- don't install a lot of stuff in tmp

Revision 1.16  2010/03/06 23:33:46  baggins
- get rid of /usr/bin/env and /usr/local/bin

Revision 1.15  2010/03/06 23:26:30  baggins
- properly install dispatchers
- fix attrs on configs and scripts

Revision 1.14  2010/03/06 23:16:45  baggins
- quiet unpackaged files

Revision 1.13  2010/03/06 22:57:00  baggins
- install example/skeleton configs

Revision 1.12  2010/03/06 22:08:50  baggins
- typo

Revision 1.11  2010/03/06 22:07:33  baggins
- added pld patch

Revision 1.10  2010/03/06 22:01:33  baggins
- install apache config
- install cgi/fcgi dispatchers
- mark config files

Revision 1.9  2010/03/06 21:40:59  baggins
- added reposman and mailhandler packages
- simplified packaging
- convert DOS newlines for patching (random files are in DOS format)
- added apache/mod_rails config

Revision 1.8  2010/03/06 01:24:00  baggins
- more files packaged

Revision 1.7  2010/03/06 00:49:30  baggins
- packaging in progress

Revision 1.6  2010/03/05 09:16:52  glen
- deps for useradd/userrremove

Revision 1.5  2010/03/04 23:14:44  baggins
- testsuite package
- added some dirs files
- silly temporary install

Revision 1.4  2010/03/04 22:34:49  baggins
- added redmine user
- slow work on getting it packaged properly

Revision 1.3  2010/03/01 13:07:10  baggins
- 0.9.3
- updated R,S

Revision 1.2  2009/02/17 14:02:53  radek
- version 0.8.1, updated R/BR

Revision 1.1  2008/10/12 10:28:32  glen
- new, unfinished
